import com.java4less.textprinter.*;
import com.java4less.textprinter.ports.*;
import com.java4less.textprinter.printers.*;
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;


public class Examples extends JFrame {
   FilePort port;
   TextPrinter printer;


  JButton btnPrint = new JButton();
  JButton btnQuit = new JButton();
  JLabel jLabel1 = new JLabel();
  JTextField txtPrinter = new JTextField();
  JLabel jLabel2 = new JLabel();
  JLabel jLabel3 = new JLabel();
  JLabel jLabel4 = new JLabel();
  JLabel jLabel5 = new JLabel();
  JComboBox comboType = new JComboBox();
  JLabel jLabel6 = new JLabel();
  JComboBox comboExample = new JComboBox();

  public Examples() {
    try {
      jbInit();

      comboType.addItem("Plain");
      comboType.addItem("IBM proprinter or compatible");
      comboType.addItem("Epson ESC/P or compatible");
      comboType.addItem("Epson ESC/P2 or compatible");
      comboType.addItem("HP PCL 3 (Laser Jet Plus Emulation)");
      comboType.addItem("HP PCL 5 or compatible");
      comboType.setSelectedIndex(0);

      comboExample.addItem("Print Purchase Order report");
      comboExample.addItem("Print Test Character Pitch");
      comboExample.addItem("Print Test Line spacing");
      comboExample.addItem("Print Test Character set");
      comboExample.addItem("Print Test Lines");
      comboExample.addItem("Print Test Font Styles");
      comboExample.addItem("Print Test Fonts");
      comboExample.setSelectedIndex(0);

      this.setSize(490,315);
      this.setLocation(200,200);

    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  public static void main(String[] args) {
    Examples examples1 = new Examples();
    examples1.setVisible(true);
  }

  private void jbInit() throws Exception {
    btnPrint.setText("Print");
    btnPrint.setBounds(new Rectangle(124, 241, 79, 27));
    btnPrint.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnPrint_actionPerformed(e);
      }
    });
    this.getContentPane().setLayout(null);
    btnQuit.setText("Quit");
    btnQuit.setBounds(new Rectangle(239, 240, 79, 27));
    btnQuit.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnQuit_actionPerformed(e);
      }
    });
    jLabel1.setText("Printer:");
    jLabel1.setBounds(new Rectangle(19, 22, 87, 17));
    txtPrinter.setText("PRN:");
    txtPrinter.setBounds(new Rectangle(65, 22, 107, 21));
    jLabel2.setText("PRN: (local windows printer)");
    jLabel2.setBounds(new Rectangle(181, 24, 172, 17));
    jLabel3.setBounds(new Rectangle(182, 43, 172, 17));
    jLabel3.setText("/dev/lpr (Linux printer)");
    jLabel4.setBounds(new Rectangle(184, 66, 275, 17));
    jLabel4.setText("\\\\Server\\printerName (windows networh printer)");
    jLabel5.setText("Type");
    jLabel5.setBounds(new Rectangle(19, 128, 41, 17));
    comboType.setBounds(new Rectangle(79, 127, 216, 21));
    jLabel6.setText("Example");
    jLabel6.setBounds(new Rectangle(19, 174, 59, 17));
    comboExample.setBounds(new Rectangle(79, 172, 371, 21));
    this.setTitle("Textprinter examples");
    this.getContentPane().add(jLabel1, null);
    this.getContentPane().add(txtPrinter, null);
    this.getContentPane().add(jLabel4, null);
    this.getContentPane().add(jLabel2, null);
    this.getContentPane().add(jLabel3, null);
    this.getContentPane().add(btnQuit, null);
    this.getContentPane().add(btnPrint, null);
    this.getContentPane().add(jLabel5, null);
    this.getContentPane().add(comboType, null);
    this.getContentPane().add(jLabel6, null);
    this.getContentPane().add(comboExample, null);
  }

  void btnQuit_actionPerformed(ActionEvent e) {
        System.exit(0);
  }

  void btnPrint_actionPerformed(ActionEvent e) {
    try {

       this.port=new FilePort(this.txtPrinter.getText());
      //this.port=new FilePort("c:\\a.txt");


      this.printer=PrinterFactory.getPrinter("PLAIN");
      if (this.comboType.getSelectedIndex()==1)  this.printer=PrinterFactory.getPrinter("IBM-PROPRINTER");
      if (this.comboType.getSelectedIndex()==2)  this.printer=PrinterFactory.getPrinter("EPSON-ESCP");
      if (this.comboType.getSelectedIndex()==3)  this.printer=PrinterFactory.getPrinter("EPSON-ESCP2");
      if (this.comboType.getSelectedIndex()==4)  this.printer=PrinterFactory.getPrinter("HP-PCL3");
      if (this.comboType.getSelectedIndex()==5)  this.printer=PrinterFactory.getPrinter("HP-PCL5");

      if (this.comboExample.getSelectedIndex()==0) this.order();
      if (this.comboExample.getSelectedIndex()==1) this.pitch();
      if (this.comboExample.getSelectedIndex()==2) this.interspacing();
      if (this.comboExample.getSelectedIndex()==3) this.charset();
      if (this.comboExample.getSelectedIndex()==4) this.lines();
      if (this.comboExample.getSelectedIndex()==5) this.fontStyle();
      if (this.comboExample.getSelectedIndex()==6) this.proportionalFont();


    } catch (Exception ex) {
      ex.printStackTrace();
    }
  }


   /**
    * test characters set conversion
    */
   public void order() {

    try {
      JobProperties job= printer.getDefaultJobProperties();

      printer.startJob(port,job);

      job.pitch=12;

      TextProperties prop=printer.getDefaultTextProperties();
      TextProperties propBold=printer.getDefaultTextProperties();
      propBold.bold=true;
      TextProperties propItalic=printer.getDefaultTextProperties();
      propItalic.italic=true;

      // Order header
      printer.printString("Purchase Order", 3,9,propBold);

      printer.printString("High", 7,21,prop);
      printer.printString("London", 7,41,prop);
      printer.printString("Elmfield Road 3", 6,41,prop);
      printer.printString("Company1", 5,41,prop);
      printer.printString("X", 8,21,prop);
      printer.printString("13/00/1999",6, 21,prop);
      printer.printString("O109Bis", 5,21,prop);
      printer.printString("Approved", 8,9,prop);
      printer.printString("Priority", 7,9,prop);
      printer.printString("Number", 5,9,prop);
      printer.printString("Date", 6,9,prop);


      // detail header
      printer.printString("Priority",12, 38,propBold);
      printer.printString("Amount",12, 64,propBold);
      printer.printString("Price",12, 58,propBold);
      printer.printString("Quantity",12, 48,propBold);
      printer.printString("Description",12, 20,propBold);
      printer.printString("Article",12, 10,propBold);

      // frame
      printer.printRectangle(8,11,71,31);
      printer.printHorizontalLine(13,8,71);

      // line 1
      printer.printString("Low",14, 41,prop);
      printer.printString("300",14, 65,prop);
      printer.printString("1",14, 58,prop);
      printer.printString("300",14, 50,prop);
      printer.printString("123456789012345678",14, 22,prop);
      printer.printString("A0301",14, 9,prop);

      // line 2
      printer.printString("Low",16, 41,prop);
      printer.printString("200",16, 65,prop);
      printer.printString("1",16, 58,prop);
      printer.printString("200",16, 50,prop);
      printer.printString("CD-ROM writer",16, 22,prop);
      printer.printString("B0301",16, 9,prop);

      // line 3
      printer.printString("Medium",18, 41,prop);
      printer.printString("330",18, 65,prop);
      printer.printString("1",18, 58,prop);
      printer.printString("330",18, 50,prop);
      printer.printString("Laptop SP",18, 22,prop);
      printer.printString("C0405",18, 9,prop);


      // total
      printer.printString("830",32, 65,prop);
      printer.printString("Total",32, 58,prop);

      // page footer
      printer.printString("Page 1", 56,65,propItalic);

      printer.endJob();
    } catch (Exception e) {
      e.printStackTrace();
    }
   }

   /**
    * test characters set conversion
    */
   public void charset() {

    try {
      JobProperties job= printer.getDefaultJobProperties();
      job.autoChartSetSelection=true;
      job.topMargin=3;
      printer.startJob(port,job);
      //job.topMargin=5;


      printer.printString("Trying to print some characters that require a symbol set change: ");
      printer.newLine();
      printer.printString("Accents:          ");
      printer.newLine();
      printer.printString("Diaeresis:     ");
      printer.newLine();

      printer.endJob();
    } catch (Exception e) {
      e.printStackTrace();
    }
   }

   /**
    * test proportional fonts
    */
  public void proportionalFont() {

    try {
     JobProperties job= printer.getDefaultJobProperties();
     job.proportional=true;

     printer.calculatePitchAndHMI=true;
      job.paperSize=PaperSize.A4;
      job.cols=80;
      printer.startJob(port,job);



      TextProperties p=printer.getDefaultTextProperties();
      p.fontName="Arial";
      p.proportional=true;
      printer.printString("Proportional characters test 0",9,0,p);
      printer.printString("Print at line 10 column 0",10,0,p);
      printer.printString("Print at line 11 column 20",11,20,p);
      printer.printString("Print at line 12 column 40",12,40,p);
      printer.printString("Print at line 13 column 60",13,60,p);

     TextProperties t=printer.getDefaultTextProperties();
      t.proportional=false;
      t.fontName="Letter Gothic";
      printer.printString("Fixed Characters test",19,0,t);
      printer.printString("Print at line 20 column 0",20,0,t);
      printer.printString("Print at line 21 column 20",21,20,t);
      printer.printString("Print at line 22 column 40",22,40,t);
      printer.printString("Print at line 23 column 60",23,60,t);

      printer.endJob();
    } catch (Exception e) {
      e.printStackTrace();
    }
   }


   /**
    * test line drawing
    */
   public void lines() {

    try {
      JobProperties job= printer.getDefaultJobProperties();
      printer.startJob(port,job);

      printer.printRectangle(10,10,60,50);
      printer.printHorizontalLine(15,10,60);
      printer.printVerticalLine(35,10,50);

      printer.endJob();
    } catch (Exception e) {
      e.printStackTrace();
    }
   }

   /**
    * test line spacing
    */
   public void interspacing() {

    try {
      JobProperties job= printer.getDefaultJobProperties();
      job.topMargin=3;
      job.interspacing="1/8";

      printer.startJob(port,job);

      printer.printString("This is a 1/8 line spcaing example. The following 8 lines will be take 1 inch");
      printer.newLine();
      for (int i=0;i<8;i++) {
          printer.printString("Line "+i);
          printer.newLine();
      }

      printer.endJob();
    } catch (Exception e) {
      e.printStackTrace();
    }
   }

    /**
    * test character size
    */
   public void pitch() {

    try {
      JobProperties job= printer.getDefaultJobProperties();
      job.topMargin=3;
      job.pitch=12;

      printer.startJob(port,job);

      printer.printString("This is a pitch (font size) example ( 12 characters per inch):");
      printer.newLine();
      printer.printString("123456789012");
      printer.newLine();

      TextProperties t=printer.getDefaultTextProperties();
      t.pitch=10;
      printer.printString("This is a pitch (font size) example ( 10 characters per inch):");
      printer.newLine();
      printer.printString("123456789012",t);

      printer.endJob();
    } catch (Exception e) {
      e.printStackTrace();
    }
   }

    /**
    * test font style
    */
  public void fontStyle() {

    try {

      JobProperties job= printer.getDefaultJobProperties();
      job.topMargin=3;
      printer.startJob(port,job);
      // NORMAL
      TextProperties prop=new TextProperties();
      printer.printString("This must be NORMAL",prop);
      printer.newLine();

      // BOLD
      prop=new TextProperties();
      prop.bold=true;
      printer.printString("This must be BOLD",prop);
      printer.newLine();

      // ITALIC
      prop=new TextProperties();
      prop.italic=true;
      printer.printString("This must be ITALIC",prop);
      printer.newLine();

      // underlined
      prop=new TextProperties();
      prop.underlined=true;
      printer.printString("This must be UNDERLINED",prop);
      printer.newLine();

      // double wide
      prop=new TextProperties();
      prop.doubleWide=true;
      printer.printString("This must be double wide",prop);
      printer.newLine();

      // double strike
      prop=new TextProperties();
      prop.doubleStrike=true;
      printer.printString("This must be double strike",prop);
      printer.newLine();

      // subscript
      prop=new TextProperties();
      prop.subscript=true;
      printer.printString("This must be subscript",prop);
      printer.newLine();

      // superscript
      prop=new TextProperties();
      prop.superscript=true;
      printer.printString("This must be superscript",prop);
      printer.newLine();

      printer.endJob();

    } catch (Exception e) {
      e.printStackTrace();
    }

  }

}
